# Refined radial basis function-generated finite difference analysis of non-Newtonian natural
### Abstract
>In this paper we present a refined Radial Basis Function-generated Finite Difference (RBF-FD) solution for a non-Newtonian fluid in a closed differentially heated cavity. The non-Newtonian behaviour is modelled with the Ostwald-de Waele power law and the buoyancy with the Boussinesq approximation. The problem domain is discretised with scattered nodes without any requirement for a topological relation between them. This allows a trivial generalisation of the solution procedure to complex irregular three dimensional (3D) domains, which is also demonstrated by solving the problem in a two dimensional (2D) and 3D geometry mimicking a porous filter. The results in 2D are compared with two reference solutions that use the Finite volume method in a conjunction with two different stabilisation techniques, where we achieved good agreement with the reference data. The refinement is implemented on top of a dedicated meshless node positioning algorithm using piecewise linear node density function that ensures sufficient node density in the centre of the domain while maximising the node density in a boundary layer where the most intense dynamic is expected. The results show that with a refined approach, more than 5 times fewer nodes are required to obtain the results with the same accuracy compared to the regular discretisation. The paper also discusses the convergence for different scenarios for up to $2 \cdot 10^5$ nodes, the impact of method parametres, the behaviour of the flow in the boundary layer, the behaviour of the viscosity and the geometric flexibility of the proposed solution procedure.

### Repository contents

This repository contains the code used to generate the results shown in the paper, the plotting scripts for the visualisations and data required to re-create them. The solution process is implemented in `c++` using the [medusa](https://e6.ijs.si/medusa/) library for meshless approximation of derivatives. The library is freely availiable on [git](https://gitlab.com/e62Lab/medusa.git) and has to be cloned (the current cmake assumes the home directory) in order for the code to function properly. The analysis/visualisation scripts are implemented in `python` with the data drawn from the condensed data set stored using the [git-lfs](https://git-lfs.com/) functionality. For additional data or explanations please contact the authors.

Additional mirror for the code and data is available at `https://doi.org/10.5281/zenodo.14901943`.